---
title: mask-size
slug: Web/CSS/mask-size
tags:
  - CSS
  - CSS Masking
  - CSS Property
  - Experimental
  - Reference
  - 'recipe:css-property'
---
<div>{{CSSRef}}</div>

<p>The <strong><code>mask-size</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> property specifies the sizes of the mask images. The size of the image can be fully or partially constrained in order to preserve its intrinsic ratio.</p>

<pre class="brush: css no-line-numbers notranslate">/* Keywords syntax */
mask-size: cover;
mask-size: contain;

/* One-value syntax */
/* the width of the image (height set to 'auto') */
mask-size: 50%;
mask-size: 3em;
mask-size: 12px;
mask-size: auto;

/* Two-value syntax */
/* first value: width of the image, second value: height */
mask-size: 50% auto;
mask-size: 3em 25%;
mask-size: auto 6px;
mask-size: auto auto;

/* Multiple values */
/* Do not confuse this with mask-size: auto auto */
mask-size: auto, auto;
mask-size: 50%, 25%, 25%;
mask-size: 6px, auto, contain;

/* Global values */
mask-size: inherit;
mask-size: initial;
mask-size: unset;
</pre>

<div class="note"><strong>Note:</strong> If the value of this property is not set in a {{cssxref("mask")}} shorthand property that is applied to the element after the <code>mask-size</code> CSS property, the value of this property is then reset to its initial value by the shorthand property.</div>

<h2 id="Syntax">Syntax</h2>

<p>One or more <code>&lt;bg-size&gt;</code> values, separated by commas.</p>

<p>A <code>&lt;bg-size&gt;</code> can be specified in one of three ways:</p>

<ul>
 <li>using the keyword <code><a href="#contain">contain</a></code></li>
 <li>using the keyword <code><a href="#cover">cover</a></code></li>
 <li>using width and height values</li>
</ul>

<p>To specify a size using width and height, you can supply one or two values:</p>

<ul>
 <li>If only one value is given it sets the width, with the height set to <code><a href="#auto">auto</a></code>.</li>
 <li>If two values are given, the first sets width and the second sets height.</li>
</ul>

<p>Each value can be a <code><a href="#length">&lt;length&gt;</a></code>, a <code><a href="#&lt;percentage&gt;">&lt;percentage&gt;</a></code>, or <code><a href="#auto">auto</a></code>.</p>

<h3 id="Values">Values</h3>

<dl>
 <dt><code>&lt;length&gt;</code></dt>
 <dd>A <code>{{cssxref("&lt;length&gt;")}}</code> value scales the mask image to the specified length in the corresponding dimension. Negative lengths are not allowed.</dd>
 <dt><code>&lt;percentage&gt;</code></dt>
 <dd>A {{cssxref("&lt;percentage&gt;")}} value scales the mask image in the corresponding dimension to the specified percentage of the mask positioning area, which is determined by the value of {{cssxref("mask-origin")}}. The mask positioning area is, by default, the area containing the content of the box and its padding; the area may also be changed to just the content or to the area containing borders, padding and content. Negative percentages are not allowed.</dd>
 <dt><a id="auto"><code>auto</code></a></dt>
 <dd>A keyword that scales the mask image in the corresponding directions in order to maintain its intrinsic proportion.</dd>
 <dt><a id="contain"><code>contain</code></a></dt>
 <dd>A keyword that scales the image as large as possible and maintains image aspect ratio (image doesn't get squished). The image is <em>letterboxed</em> within the container. The image is automatically centered unless over-ridden by another property such as {{cssxref("mask-position")}}.</dd>
 <dt><a id="cover"><code>cover</code></a></dt>
 <dd>A keyword that is the inverse of <code>contain</code>. Scales the image as large as possible and maintains image aspect ratio (image doesn't get squished). The image "covers" the entire width or height of the container. When the image and container have different dimensions, <em>the image is clipped</em> either on left/right or at top/bottom.</dd>
</dl>

<p>The interpretation of possible values depends on the image's intrinsic dimensions (width and height) and intrinsic proportion (ratio of width and height). A bitmap image always has intrinsic dimensions and an intrinsic proportion. A vector image may have both intrinsic dimensions and thus it has an intrinsic proportion too. It also may have one or no intrinsic dimensions and in either case it might or might not have an intrinsic proportion. Gradients are treated as images with no intrinsic dimensions or intrinsic proportion.</p>

<p>The rendered size of the mask image is then computed as follows:</p>

<dl>
 <dt>If both components of <code>mask-size</code> are specified and are not <code>auto</code>:</dt>
 <dd>The mask image renders at the specified size.</dd>
 <dt>If the <code>mask-size</code> is <code>contain</code> or <code>cover</code>:</dt>
 <dd>The image is rendered by preserving its intrinsic proportion at the largest size contained within or covering the mask positioning area. If the image has no intrinsic proportion, then it is rendered at the size of the mask positioning area.</dd>
 <dt>If the <code>mask-size</code> is <code>auto</code> or <code>auto auto</code>:</dt>
 <dd>If the image has both intrinsic dimensions, it is rendered at that size. If it has no intrinsic dimensions and no intrinsic proportion, it is rendered at the size of the mask positioning area. If it has no dimensions but has a proportion, it's rendered as if <code>contain</code> had been specified instead. If the image has one intrinsic dimension and a proportion, it's rendered at the size determined by that one dimension and the proportion. If the image has one intrinsic dimension but no proportion, it's rendered using the intrinsic dimension and the corresponding dimension of the mask positioning area.</dd>
 <dt>If <code>mask-size</code> has one <code>auto</code> component and one non-<code>auto</code> component:</dt>
 <dd>If the image has an intrinsic proportion, then render it using the specified dimension and compute the other dimension from the specified dimension and the intrinsic proportion. If the image has no intrinsic proportion, use the specified dimension for that dimension. For the other dimension, use the image's corresponding intrinsic dimension if there is one. If there is no such intrinsic dimension, use the corresponding dimension of the mask positioning area.</dd>
</dl>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{cssinfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>
<h2 id="Examples">Examples</h2>

<h3 id="Setting_mask_size_as_a_percentage">Setting mask size as a percentage</h3>

<h4 id="CSS">CSS</h4>

<pre class="brush: css; highlight[6] notranslate">#masked {
  width: 200px;
  height: 200px;
  background: blue linear-gradient(red, blue);
  -webkit-mask-image: url(https://mdn.mozillademos.org/files/12668/MDN.svg);
  mask-image: url(https://mdn.mozillademos.org/files/12668/MDN.svg);
  -webkit-mask-size: 50%;
  mask-size: 50%; /* Can be changed in the live sample */
  margin-bottom: 10px;
}
</pre>

<div class="hidden">
<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;div id="masked"&gt;
&lt;/div&gt;
&lt;select id="maskSize"&gt;
  &lt;option value="auto"&gt;auto&lt;/option&gt;
  &lt;option value="40% 80%"&gt;40% 80%&lt;/option&gt;
  &lt;option value="50%" selected&gt;50%&lt;/option&gt;
  &lt;option value="200px 100px"&gt;200px 100px&lt;/option&gt;
  &lt;option value="cover"&gt;cover&lt;/option&gt;
  &lt;option value="contain"&gt;contain&lt;/option&gt;
&lt;/select&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js notranslate">var maskSize = document.getElementById("maskSize");
maskSize.addEventListener("change", function (evt) {
  document.getElementById("masked").style.maskSize = evt.target.value;
});
</pre>
</div>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample("Setting_mask_size_as_a_percentage", 210, 240)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("CSS Masks", "#the-mask-size", "mask-size")}}</td>
   <td>{{Spec2("CSS Masks")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.mask-size")}}</p>

<h2 id="See_also">See also</h2>

<ul>
  <li><a href="https://css-tricks.com/clipping-masking-css/">Clipping and Masking in CSS</a></li>
</ul>
